Table table;
float[][] dataMatrix;
float [][] dataMatrix2;
int numRows, numCols;
float cellwidth, cellheight;
float maxCheckouts, minCheckouts, minItems, maxItems;
float constantVerticalMargin = 100, constantHorizantalMargin = 160;
int startYear = 2006;

boolean normalisation = false;
boolean colorApply = false;
boolean reorder = false;
int [] media = new int[144];
int [] book = new int[144];
int [] video = new int[144];
int [] mapmedia = new int[144];
int [] mapvideo= new int[144];
int [] mapbook = new int[144];

String [] Year = {"2005", "2006", "2007", "2008", "2009", "2010", "2011", "2012", "2013", "2014", "2015", "2016"};
int numYear = 12;
String [] Dewey = {"Info", "Phil-Psych", "SS", "Lang", "Science", "Tech", "Arts", "Lit", "History", "Media", "Video", "Book"};


//Only run one time
void setup() {
  size(1280, 720); // setup the size of the window
  // In Processing 3, the size() function must be the first line of code inside setup()
  // and needs to use numbers instead of variables. 

  table = loadTable("techvslib2.csv", "header");
  numRows = table.getRowCount();
  numCols = table.getColumnCount()-3;
  dataMatrix = new float[numCols-1][numRows];


  for ( int i = 0; i < numCols-1; i++) {
    for (int j = 0; j < numRows; j++) {
      dataMatrix[i][j] = table.getFloat(j, i+1);
    }
  }
  maxCheckouts = max2D(dataMatrix);
  minCheckouts = min2D(dataMatrix);

  println( "Max Checkouts: ", maxCheckouts, " Min Checkouts : ", minCheckouts);

  //int [] media = new int[144];
  for (int i = 0; i < 144; i++) {
    media[i] = table.getInt(i, 11);
  }
  int min_media = min(media);
  int max_media = max(media);
  //int [] mapmedia = new int[144];
  for (int i = 0; i < 144; i++) {
    mapmedia[i] = int(map(media[i], min_media, max_media, 0, 255));
  }
  //printArray(mapmedia);

  //int [] video = new int[144];
  for (int i = 0; i < 144; i++) {
    video[i] = table.getInt(i, 12);
  }
  int min_video = min(video);
  int max_video = max(video);
  //int [] mapvideo = new int[144];
  for (int i = 0; i < 144; i++) {
    mapvideo[i] = int(map(video[i], min_video, max_video, 0, 255));
  }
  //int [] book = new int[144];
  for (int i = 0; i < 144; i++) {
    book[i] = table.getInt(i, 13);
  }
  int min_book = min(book);
  int max_book = max(book);
  //int [] mapbook = new int [144];
  for (int i = 0; i < 144; i++) {
    mapbook[i] = int(map(book[i], min_book, max_book, 0, 255));
  }

  printArray(mapmedia);
}


//Refresh the canvas every frame
void draw() {  
  background(250);
  surface.setResizable(true);

  cellwidth = (width - 2*constantHorizantalMargin)/numRows;
  cellheight = (height - 2*constantVerticalMargin)/(numCols-1);

  for ( int i = 0; i < numCols-1; i++) {
    for (int j = 0; j < numRows; j++) {
      stroke(255);
      float grayscale;
      grayscale = int(map (dataMatrix[i][j], minCheckouts, maxCheckouts, -40, 40));
      //fill(grayscale);
      //float redscale = map(dataMatrix2[i][j], minItems, maxItems, 0,255);
      fill(mapmedia[j]+grayscale, mapvideo[j]+grayscale, mapbook[j]+grayscale);
      println(mapmedia[j], mapvideo[j], mapbook[j]);
      rect(constantHorizantalMargin + cellwidth*j, 
        constantVerticalMargin+cellheight*i, 
        cellwidth, 
        cellheight);
    }
  }

  for (int i = 0; i < numYear; i++) {
    fill(0);
    textAlign(CENTER, CENTER);
    textSize(14);
    text(Year[i], 40 + constantHorizantalMargin+i*80, constantVerticalMargin-10);
  }

  for (int i =0; i < numCols-1; i++) {
    textAlign(RIGHT, CENTER);
    textSize(14);
    fill(0);
    text(Dewey[i], constantHorizantalMargin, constantVerticalMargin+cellheight*i+cellheight/2);
  }
  //textSize(14);
  //textAlign(CENTER,CENTER);
  //text("Top 100 ACTIVE DEWEY FROM 2006-2014", width/2, constantVerticalMargin/2);

  //println("normalisation: " + normalisation + " colorApply : " + colorApply + " reorder : " + reorder);
  if (normalisation == true) normalise();
  else if (normalisation == false) reset();
  if (colorApply == true) colorscheme();
  if (reorder == true) resort();
  //else if(reorder == false) reset();
  save("project1.tif");
}